-- name: [CS] Peter Shorts
-- description: Custom model of Peter Shorts\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- THIS MODEL AND CHARACTER MOD WAS CREATED BY SEYMOUR AND IS NOT PERMITTED FOR RE-USE OR RE-UPLOADING.

local E_PETER_MODEL = smlua_model_util_get_id("peter_shorts_geo")

local TEX_CUSTOM_ICON = get_texture_info("peter-shorts-icon")

local TEXT_MOD_NAME = "Peter Shorts"

local SOUNDS = {
    GO = 'go.ogg',
    BBB = 'bbb.ogg',
    DIE = 'die.ogg',
    DOH = 'doh.ogg',
    HEY = 'hey.ogg',
    FALL = 'fall.ogg',
    JUMP = 'jump.ogg',
    DODGE = 'dodge.ogg',
    DOFUQ = 'dofuq.ogg',
    GACCK = 'gacck.ogg',
    KAPUT = 'kaput.ogg',
    WHISH = 'whish.ogg',
    TUMBLE = 'tumble.ogg',
    GRAB_TRY = 'grab_try.ogg',
}


local VOICETABLE_CHAR = {
    [CHAR_SOUND_YAH_WAH_HOO]            = SOUNDS.JUMP,
    [CHAR_SOUND_HOOHOO]                 = SOUNDS.JUMP,
    [CHAR_SOUND_YAHOO]                  = SOUNDS.JUMP,
    [CHAR_SOUND_UH]                     = SOUNDS.GACCK,
    [CHAR_SOUND_HRMM]                   = nil,
    [CHAR_SOUND_WAH2]                   = SOUNDS.WHISH,
    [CHAR_SOUND_WHOA]                   = SOUNDS.DODGE,
    [CHAR_SOUND_EEUH]                   = nil,
    [CHAR_SOUND_ATTACKED]               = SOUNDS.GACCK,
    [CHAR_SOUND_OOOF]                   = SOUNDS.GACCK,
    [CHAR_SOUND_OOOF2]                  = SOUNDS.DOFUQ,
    [CHAR_SOUND_HERE_WE_GO]             = SOUNDS.GO,
    [CHAR_SOUND_YAWNING]                = SOUNDS.DODGE,
    [CHAR_SOUND_SNORING1]               = nil,
    [CHAR_SOUND_SNORING2]               = SOUNDS.BBB,
    [CHAR_SOUND_SNORING3]               = nil,
    [CHAR_SOUND_WAAAOOOW]               = SOUNDS.FALL,
    [CHAR_SOUND_HAHA]                   = SOUNDS.HEY,
    [CHAR_SOUND_HAHA_2]                 = SOUNDS.HEY,
    [CHAR_SOUND_UH2]                    = nil,
    [CHAR_SOUND_UH2_2]                  = nil,
    [CHAR_SOUND_ON_FIRE]                = SOUNDS.TUMBLE,
    [CHAR_SOUND_DYING]                  = SOUNDS.DIE,
    [CHAR_SOUND_PANTING_COLD]           = nil,
    [CHAR_SOUND_PANTING]                = nil,
    [CHAR_SOUND_COUGHING1]              = SOUNDS.GRAB_TRY,
    [CHAR_SOUND_COUGHING2]              = SOUNDS.GRAB_TRY,
    [CHAR_SOUND_COUGHING3]              = SOUNDS.GRAB_TRY,
    [CHAR_SOUND_PUNCH_YAH]              = SOUNDS.WHISH,
    [CHAR_SOUND_PUNCH_WAH]              = SOUNDS.WHISH,
    [CHAR_SOUND_PUNCH_HOO]              = SOUNDS.GRAB_TRY,
    [CHAR_SOUND_MAMA_MIA]               = SOUNDS.HEY,
    [CHAR_SOUND_GROUND_POUND_WAH]       = nil,
    [CHAR_SOUND_DROWNING]               = SOUNDS.BBB,
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE]      = SOUNDS.JUMP,
    [CHAR_SOUND_DOH]                    = SOUNDS.KAPUT,
    [CHAR_SOUND_GAME_OVER]              = nil,
    [CHAR_SOUND_HELLO]                  = nil,
    [CHAR_SOUND_PRESS_START_TO_PLAY]    = nil,
    [CHAR_SOUND_TWIRL_BOUNCE]           = nil,
    [CHAR_SOUND_SO_LONGA_BOWSER]        = SOUNDS.GO,
    [CHAR_SOUND_IMA_TIRED]              = nil,
    [CHAR_SOUND_LETS_A_GO]              = SOUNDS.GO,
    [CHAR_SOUND_OKEY_DOKEY]             = nil,
    [CHAR_SOUND_MAX]                    = nil,
}

local PETER_PALETTE = {
    [SHOES] = {r=0x9c, g=0x2e, b= 0x01}, -- 9c2e01
    [SHIRT] = {r=0x9c, g=0x2e, b= 0x01}, -- 9c2e01
     [HAIR] = {r=0x66, g=0x1e, b= 0x01}, -- 661e01
     [SKIN] = {r=0xff, g=0xcb, b= 0xba}, -- ffcbba
}


local CAPTABLE_CHAR = {
    --normal      = smlua_model_util_get_id("peter_cap_normal_geo"),
    --metal       = smlua_model_util_get_id("peter_cap_normal_geo"),
    --wing        = smlua_model_util_get_id("peter_cap_wing_geo"),
    --metalWing   = smlua_model_util_get_id("peter_cap_wing_geo"),
}

if _G.charSelectExists and SM64COOPDX_VERSION then
    CT_CHAR = _G.charSelect.character_add("Peter Shorts", {"grillmeister supreme",}, "seymour schlong", "700000", E_PETER_MODEL, CT_MARIO, TEX_CUSTOM_ICON)

    -- code borrowed from brian mod.
    local curVers = _G.charSelect.version_get();
	if not tonumber(curVers) then -- if this cannot be simplified to a number, there's other strings in this
		curVers = string.gsub(curVers, "[%a%s_()!?:,@#-]+", ""); -- removing all letters, spaces, and the chars in the [set]
		
		curVers = curVers:gsub("%.", "X", 1):gsub("%.", ""):gsub("X", "."); -- removes all instances except the first decimal point
	end
	curVers = tonumber(curVers);

    if curVers >= 1.8 then
		_G.charSelect.character_add_palette_preset(E_PETER_MODEL, PETER_PALETTE);
	end

    --_G.charSelect.character_add_caps(E_PETER_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_PETER_MODEL, VOICETABLE_CHAR)
    
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end



-- BUG PETER

if not _G.wpets then return end

local E_MODEL_BUG = smlua_model_util_get_id('bug_shorts_geo')

local ID_BUG = _G.wpets.add_pet({
	name = "Bug Peter", credit = "seymour schlong",
	description = "Trusty bug companion. From You Are Peter Shorts",
	modelID = E_MODEL_BUG,
	scale = 1.0, yOffset = 0, flying = true
})

_G.wpets.set_pet_anims_wing(ID_BUG)

_G.wpets.set_pet_sounds(ID_BUG, {
	spawn = 'hey.ogg',
	happy = {'bbb.ogg','doh.ogg'},
	vanish = nil,
	step = nil
})

-- required hook for samples (audio files from the mod's 'sound' folder)
-- if no pets in your pack use samples, you can remove this section.
hook_event(HOOK_UPDATE, function ()
	-- copy the following line for each pet in the pack that uses samples.
    _G.wpets.process_pet_samples(ID_BUG)
end)